Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | METHOD | DETAIL: FIELD | METHOD

## org.gradle.api.tasks
[Java] Interface TaskContainer

    org.gradle.api.DomainObjectCollection
      org.gradle.api.NamedDomainObjectCollection
          org.gradle.api.NamedDomainObjectContainer
              org.gradle.api.tasks.TaskCollection
                  org.gradle.api.tasks.TaskContainer

All Superinterfaces:
  DomainObjectCollection, NamedDomainObjectCollection, TaskCollection, NamedDomainObjectContainer

    public interface TaskContainer
    extends NamedDomainObjectContainer, TaskCollection

A `TaskContainer` is responsible for managing a set of Task instances.

You can obtain a `TaskContainer` instance by calling Project.getTasks, or using the `tasks` property in your build script.

Method Summary
`Task` | `add(java.util.Map options)` Creates a Task and adds it to this container.
`Task` | `add(java.util.Map options, groovy.lang.Closure configureClosure)` Creates a Task adds it to this container.
`Task` | `add(java.lang.String name, groovy.lang.Closure configureClosure)` Creates a Task with the given name adds it to this container.
`Task` | `add(java.lang.String name)` Creates a Task with the given name and adds it to this container.
`T` | `add(java.lang.String name, java.lang.Class type)` Creates a Task with the given name and type, and adds it to this container.
`Task` | `findByPath(java.lang.String path)` Locates a task by path.
`Task` | `getByPath(java.lang.String path)` Locates a task by path.
`Task` | `replace(java.lang.String name)` Creates a Task with the given name and adds it to this container, replacing any existing task with the same name.
`T` | `replace(java.lang.String name, java.lang.Class type)` Creates a Task with the given name and type, and adds it to this container, replacing any existing task of the same name.

Methods inherited from interface TaskCollection
allTasks, allTasks, getAt, getByName, getByName, matching, matching, whenTaskAdded, whenTaskAdded, withType

Methods inherited from interface NamedDomainObjectContainer
addRule, addRule, getRules

Method Detail

### add

    public Task add(java.util.Map options)

  Creates a Task and adds it to this container. A map of creation options can be passed to this method to control how the task is created. The following options are available:

  Option | Description | Default Value
  --- | --- | ---
  `{ value: org.gradle.api.Task#TASK_NAME}` | The name of the task to create. | None. Must be specified.
  `{@value org.gradle.api.Task#TASK_TYPE}` | The class of the task to create. | DefaultTask
  `{@value org.gradle.api.Task#TASK_ACTION}` | The closure or TaskAction to execute when the task executes. See Task#doFirst(Action)#doFirst(Action). | `null`
  `{@value org.gradle.api.Task#TASK_OVERWRITE}` | Replace an existing task? | `false`
  `{@value org.gradle.api.Task#TASK_DEPENDS_ON}` | The dependencies of the task. See here for more details. | `[]`

  After the task is added, it is made available as a property of the project, so that you can reference the task by name in your build file. See here for more details.

  If a task with the given name already exists in this container and the `override` option is not set to true, an exception is thrown.

throws:
  InvalidUserDataException If a task with the given name already exsists in this project.

Parameters:
  `options` - The task creation options.

Returns:
  The newly created task object

### add

    public Task add(java.util.Map options, groovy.lang.Closure configureClosure)

  Creates a Task adds it to this container. A map of creation options can be passed to this method to control how the task is created. See add(java.util.Map) for the list of options available. The given closure is used to configure the task before it is returned by this method.

  After the task is added, it is made available as a property of the project, so that you can reference the task by name in your build file. See here for more details.

  throws:
    InvalidUserDataException If a task with the given name already exsists in this project.
  Parameters:
    `options` - The task creation options.
    `configureClosure` - The closure to use to configure the task.
  Returns:
    The newly created task object

### add

    public Task add(java.lang.String name, groovy.lang.Closure configureClosure)

  Creates a Task with the given name adds it to this container. The given closure is used to configure the task before it is returned by this method.

  After the task is added, it is made available as a property of the project, so that you can reference the task by name in your build file. See here for more details.

  throws:
    InvalidUserDataException If a task with the given name already exsists in this project.
  Parameters:
    `name` - The name of the task to be created
    `configureClosure` - The closure to use to configure the task.
  Returns:
    The newly created task object

### add

    public Task add(java.lang.String name)

  Creates a Task with the given name and adds it to this container.

  After the task is added, it is made available as a property of the project, so that you can reference the task by name in your build file. See here for more details.

  throws:
    InvalidUserDataException If a task with the given name already exsists in this project.
  Parameters:
    `name` - The name of the task to be created
  Returns:
    The newly created task object

### add

    public T add(java.lang.String name, java.lang.Class type)

  Creates a Task with the given name and type, and adds it to this container.

  After the task is added, it is made available as a property of the project, so that you can reference the task by name in your build file. See here for more details.

  throws:
    InvalidUserDataException If a task with the given name already exsists in this project.
  Parameters:
    `name` - The name of the task to be created.
    `type` - The type of task to create.
  Returns:
    The newly created task object

### findByPath

    public Task findByPath(java.lang.String path)

  Locates a task by path. You can supply a task name, a relative path, or an absolute path. Relative paths are interpreted relative to the project for this container. This method returns null if no task with the given path exists.

  Parameters:
    `path` - the path of the task to be returned
  Returns:
    The task. Returns null if so such task exists.

### getByPath

    public Task getByPath(java.lang.String path)

  Locates a task by path. You can supply a task name, a relative path, or an absolute path. Relative paths are interpreted relative to the project for this container. This method throws an exception if no task with the given path exists.

  throws:
    UnknownTaskException If no task with the given path exists.
  Parameters:
    `path` - the path of the task to be returned
  Returns:
    The task. Never returns null

### replace

    public Task replace(java.lang.String name)

  Creates a Task with the given name and adds it to this container, replacing any existing task with the same name.

  After the task is added, it is made available as a property of the project, so that you can reference the task by name in your build file. See here for more details.

  throws:
    InvalidUserDataException If a task with the given name already exsists in this project.
  Parameters:
    `name` - The name of the task to be created
  Returns:
    The newly created task object

### replace

    public T replace(java.lang.String name, java.lang.Class type)

  Creates a Task with the given name and type, and adds it to this container, replacing any existing task of the same name.

  After the task is added, it is made available as a property of the project, so that you can reference the task by name in your build file. See here for more details.

  throws:
    InvalidUserDataException If a task with the given name already exsists in this project.
  Parameters:
    `name` - The name of the task to be created.
    `type` - The type of task to create.
  Returns:
    The newly created task object

Groovy Documentation